Guides

Form Groups

When building a multi-stage form that has many stages, like so:

Form stepper

It's common for each step to have its own form. However, this complicates the form submission and validation process by requiring you to add complex logic.

Luckily, TanStack Form provides a way to build out sub-forms that make this kind of development trivial to implement: <form.FormGroup>.

Usage

To use a form group in TanStack Form, you'll use createForm or useAppForm to create a form variable, then reference its FormGroup component like you would a Field:

tsx
const form = createForm(() => ({
  defaultValues: {
    step1: {
      name: '',
    },
    step2: {
      age: 0,
    },
  },
}))

return (
  <form.FormGroup name="step1">
    {(group) => (
      // `group()` here has all of the form-like methods you'd expect like `deleteField` or `insertFieldValue`
      // ...
    )}
  </form.FormGroup>
)
const form = createForm(() => ({
  defaultValues: {
    step1: {
      name: '',
    },
    step2: {
      age: 0,
    },
  },
}))

return (
  <form.FormGroup name="step1">
    {(group) => (
      // `group()` here has all of the form-like methods you'd expect like `deleteField` or `insertFieldValue`
      // ...
    )}
  </form.FormGroup>
)

This becomes much more useful when paired with external state to conditionally render a FormGroup:

tsx
const [step, setStep] = createSignal(0)
const form = createForm(() => ({
  defaultValues: {
    step1: {
      name: '',
    },
    step2: {
      age: 0,
    },
  },
}))

return (
  <>
    <Show when={step() === 0}>
      <form.FormGroup
        name="step1"
        onGroupSubmit={() => {
          // We can move the step forward when validation passes
          setStep(step() + 1)
        }}
        onGroupSubmitInvalid={() => {
          // Or handle invalid submissions, just like a top-level form
        }}
        onSubmitMeta={{} as SomeType}
      >
        {(group) => (
          // Use `group().handleSubmit()` to submit the sub-form, but not the parent form
          // ...
        )}
      </form.FormGroup>
    </Show>
    <Show when={step() === 1}>
      <form.FormGroup name="step2">
        {(group) => (
          // Then, use `form.handleSubmit()` to submit the entire form
          // ...
        )}
      </form.FormGroup>
    </Show>
  </>
)
const [step, setStep] = createSignal(0)
const form = createForm(() => ({
  defaultValues: {
    step1: {
      name: '',
    },
    step2: {
      age: 0,
    },
  },
}))

return (
  <>
    <Show when={step() === 0}>
      <form.FormGroup
        name="step1"
        onGroupSubmit={() => {
          // We can move the step forward when validation passes
          setStep(step() + 1)
        }}
        onGroupSubmitInvalid={() => {
          // Or handle invalid submissions, just like a top-level form
        }}
        onSubmitMeta={{} as SomeType}
      >
        {(group) => (
          // Use `group().handleSubmit()` to submit the sub-form, but not the parent form
          // ...
        )}
      </form.FormGroup>
    </Show>
    <Show when={step() === 1}>
      <form.FormGroup name="step2">
        {(group) => (
          // Then, use `form.handleSubmit()` to submit the entire form
          // ...
        )}
      </form.FormGroup>
    </Show>
  </>
)

Form Group Validation

Form groups have a distinct validation proceedure that we think makes sense for sub-forms:

  • Form groups can have their own validation:
tsx
<form.FormGroup name="step1" validators={{ onChange: () => 'Error' }}>
  {(group) => {
    group().state.meta.errorMap // {onChange: "Error" | undefined}
    group().state.meta.errors // ("Error")[]
  }}
</form.FormGroup>
<form.FormGroup name="step1" validators={{ onChange: () => 'Error' }}>
  {(group) => {
    group().state.meta.errorMap // {onChange: "Error" | undefined}
    group().state.meta.errors // ("Error")[]
  }}
</form.FormGroup>
  • Can set errors on sub-fields:
tsx
<form.FormGroup
  name="step1"
  validators={{
    onChange: ({ value, groupApi }) => ({
      group: value.name === 'error' ? 'Group error' : undefined,
      fields: {
        // Must use the name of the field relative to the FormGroup as the error key,
        // to stay consistent with how standard schema works with form groups
        name: value.name === 'error' ? 'Field error' : undefined,
      },
    }),
  }}
/>
<form.FormGroup
  name="step1"
  validators={{
    onChange: ({ value, groupApi }) => ({
      group: value.name === 'error' ? 'Group error' : undefined,
      fields: {
        // Must use the name of the field relative to the FormGroup as the error key,
        // to stay consistent with how standard schema works with form groups
        name: value.name === 'error' ? 'Field error' : undefined,
      },
    }),
  }}
/>
  • And can even accept standard schemas:
tsx
<form.FormGroup
  name="step1"
  validators={{
    onChange: z.object({
      name: z.string().min(2),
    }),
  }}
/>
<form.FormGroup
  name="step1"
  validators={{
    onChange: z.object({
      name: z.string().min(2),
    }),
  }}
/>

The reason we don't use the full path names for fields is so that you can compose your schemas like so:

plaintext
const step1Schema = z.object({
    name: z.string().min(2)
})

const schema = z.object({
    step1: step1Schema,
    step2: step2Schema
})
const step1Schema = z.object({
    name: z.string().min(2)
})

const schema = z.object({
    step1: step1Schema,
    step2: step2Schema
})

And pass the step1Schema to a form group and schema to the parent form. That way, partially validated data will still flag errors if the group is bypassed.

Dynamic Group Validation

If you want to use dynamic validation (onDynamic) with a form group, do not rely on the onDynamic validator passed to createForm:

tsx
createForm(() => ({
  validationLogic: revalidateLogic(),
  validators: {
    // This validator will not run `onChange` when a sub-form is submitted;
    // it will only run `onChange` when the form itself is submitted.
    onDynamic: schema,
  },
}))
createForm(() => ({
  validationLogic: revalidateLogic(),
  validators: {
    // This validator will not run `onChange` when a sub-form is submitted;
    // it will only run `onChange` when the form itself is submitted.
    onDynamic: schema,
  },
}))

Instead, pass your sub-schema for the group to the onDynamic validation of the FormGroup itself:

tsx
<form.FormGroup validators={{ onDynamic: step1Schema }} />
<form.FormGroup validators={{ onDynamic: step1Schema }} />

It will treat group().submissionAttempts as the way to change what validator is ran before/after submit.

Form Group State

Just like you're able to access group().state.meta.errors, you're also able to access the group's value using group().state.value. Likewise, here are some valuable properties you can access in the group().state.meta:

  • group().state.meta.isFieldsValid: true when the field-level validators have no errors
  • group().state.meta.isGroupValid: true when the group-level validators have no errors
  • group().state.meta.isValid: true when both the field-level and group-level validators have no errors
  • group().state.meta.isSubmitting: true when the group is in the process of being submitted

Guides

Form Groups

When building a multi-stage form that has many stages, like so:

Form stepper

It's common for each step to have its own form. However, this complicates the form submission and validation process by requiring you to add complex logic.

Luckily, TanStack Form provides a way to build out sub-forms that make this kind of development trivial to implement: <form.FormGroup>.

Usage

To use a form group in TanStack Form, you'll use useForm to create a form variable, then reference its FormGroup component like you would a Field:

vue
<script setup lang="ts">
import { useForm } from '@tanstack/vue-form'

const form = useForm({
  defaultValues: {
    step1: {
      name: '',
    },
    step2: {
      age: 0,
    },
  },
})
</script>

<template>
  <form.FormGroup name="step1" v-slot="{ group: formGroup }">
    <!-- `formGroup` here has all of the form-like methods you'd expect like `deleteField` or `insertFieldValue` -->
    <!-- ... -->
  </form.FormGroup>
</template>
<script setup lang="ts">
import { useForm } from '@tanstack/vue-form'

const form = useForm({
  defaultValues: {
    step1: {
      name: '',
    },
    step2: {
      age: 0,
    },
  },
})
</script>

<template>
  <form.FormGroup name="step1" v-slot="{ group: formGroup }">
    <!-- `formGroup` here has all of the form-like methods you'd expect like `deleteField` or `insertFieldValue` -->
    <!-- ... -->
  </form.FormGroup>
</template>

This becomes much more useful when paired with external state to conditionally render a FormGroup:

vue
<script setup lang="ts">
import { ref } from 'vue'
import { useForm } from '@tanstack/vue-form'

const step = ref(0)

const form = useForm({
  defaultValues: {
    step1: {
      name: '',
    },
    step2: {
      age: 0,
    },
  },
})

const onGroupSubmit = () => {
  step.value++
}

const onGroupSubmitInvalid = () => {
  // Or handle invalid submissions, just like a top-level form
}
</script>

<template>
  <form.FormGroup
    v-if="step === 0"
    name="step1"
    :onGroupSubmit="onGroupSubmit"
    :onGroupSubmitInvalid="onGroupSubmitInvalid"
    :onSubmitMeta="{} as SomeType"
    v-slot="{ group: formGroup }"
  >
    <form @submit.prevent.stop="formGroup.handleSubmit()">
      <!-- Use `formGroup.handleSubmit()` to submit the sub-form, but not the parent form -->
      <!-- ... -->
    </form>
  </form.FormGroup>
  <form.FormGroup
    v-if="step === 1"
    name="step2"
    :onGroupSubmit="() => form.handleSubmit()"
    v-slot="{ group: formGroup }"
  >
    <form @submit.prevent.stop="formGroup.handleSubmit()">
      <!-- Then, use `form.handleSubmit()` to submit the entire form -->
      <!-- ... -->
    </form>
  </form.FormGroup>
</template>
<script setup lang="ts">
import { ref } from 'vue'
import { useForm } from '@tanstack/vue-form'

const step = ref(0)

const form = useForm({
  defaultValues: {
    step1: {
      name: '',
    },
    step2: {
      age: 0,
    },
  },
})

const onGroupSubmit = () => {
  step.value++
}

const onGroupSubmitInvalid = () => {
  // Or handle invalid submissions, just like a top-level form
}
</script>

<template>
  <form.FormGroup
    v-if="step === 0"
    name="step1"
    :onGroupSubmit="onGroupSubmit"
    :onGroupSubmitInvalid="onGroupSubmitInvalid"
    :onSubmitMeta="{} as SomeType"
    v-slot="{ group: formGroup }"
  >
    <form @submit.prevent.stop="formGroup.handleSubmit()">
      <!-- Use `formGroup.handleSubmit()` to submit the sub-form, but not the parent form -->
      <!-- ... -->
    </form>
  </form.FormGroup>
  <form.FormGroup
    v-if="step === 1"
    name="step2"
    :onGroupSubmit="() => form.handleSubmit()"
    v-slot="{ group: formGroup }"
  >
    <form @submit.prevent.stop="formGroup.handleSubmit()">
      <!-- Then, use `form.handleSubmit()` to submit the entire form -->
      <!-- ... -->
    </form>
  </form.FormGroup>
</template>

Form Group Validation

Form groups have a distinct validation proceedure that we think makes sense for sub-forms:

  • Form groups can have their own validation:
vue
<template>
  <form.FormGroup
    name="step1"
    :validators="{ onChange: () => 'Error' }"
    v-slot="{ group: formGroup }"
  >
    <!-- formGroup.state.meta.errorMap // {onChange: "Error" | undefined} -->
    <!-- formGroup.state.meta.errors // ("Error")[] -->
  </form.FormGroup>
</template>
<template>
  <form.FormGroup
    name="step1"
    :validators="{ onChange: () => 'Error' }"
    v-slot="{ group: formGroup }"
  >
    <!-- formGroup.state.meta.errorMap // {onChange: "Error" | undefined} -->
    <!-- formGroup.state.meta.errors // ("Error")[] -->
  </form.FormGroup>
</template>
  • Can set errors on sub-fields:
vue
<template>
  <form.FormGroup
    name="step1"
    :validators="{
      onChange: ({ value, groupApi }) => ({
        group: value.name === 'error' ? 'Group error' : undefined,
        fields: {
          // Must use the name of the field relative to the FormGroup as the error key,
          // to stay consistent with how standard schema works with form groups
          name: value.name === 'error' ? 'Field error' : undefined,
        },
      }),
    }"
  />
</template>
<template>
  <form.FormGroup
    name="step1"
    :validators="{
      onChange: ({ value, groupApi }) => ({
        group: value.name === 'error' ? 'Group error' : undefined,
        fields: {
          // Must use the name of the field relative to the FormGroup as the error key,
          // to stay consistent with how standard schema works with form groups
          name: value.name === 'error' ? 'Field error' : undefined,
        },
      }),
    }"
  />
</template>
  • And can even accept standard schemas:
vue
<template>
  <form.FormGroup
    name="step1"
    :validators="{
      onChange: z.object({
        name: z.string().min(2),
      }),
    }"
  />
</template>
<template>
  <form.FormGroup
    name="step1"
    :validators="{
      onChange: z.object({
        name: z.string().min(2),
      }),
    }"
  />
</template>

The reason we don't use the full path names for fields is so that you can compose your schemas like so:

ts
const step1Schema = z.object({
  name: z.string().min(2),
})

const schema = z.object({
  step1: step1Schema,
  step2: step2Schema,
})
const step1Schema = z.object({
  name: z.string().min(2),
})

const schema = z.object({
  step1: step1Schema,
  step2: step2Schema,
})

And pass the step1Schema to a form group and schema to the parent form. That way, partially validated data will still flag errors if the group is bypassed.

Dynamic Group Validation

If you want to use dynamic validation (onDynamic) with a form group, do not rely on the onDynamic validator passed to useForm:

ts
useForm({
  validationLogic: revalidateLogic(),
  validators: {
    // This validator will not run `onChange` when a sub-form is submitted;
    // it will only run `onChange` when the form itself is submitted.
    onDynamic: schema,
  },
})
useForm({
  validationLogic: revalidateLogic(),
  validators: {
    // This validator will not run `onChange` when a sub-form is submitted;
    // it will only run `onChange` when the form itself is submitted.
    onDynamic: schema,
  },
})

Instead, pass your sub-schema for the group to the onDynamic validation of the FormGroup itself:

vue
<template>
  <form.FormGroup name="step1" :validators="{ onDynamic: step1Schema }" />
</template>
<template>
  <form.FormGroup name="step1" :validators="{ onDynamic: step1Schema }" />
</template>

It will treat formGroup.submissionAttempts as the way to change what validator is ran before/after submit.

Form Group State

Just like you're able to access formGroup.state.meta.errors, you're also able to access the group's value using formGroup.state.value. Likewise, here are some valuable properties you can access in the formGroup.state.meta:

  • formGroup.state.meta.isFieldsValid: true when the field-level validators have no errors
  • formGroup.state.meta.isGroupValid: true when the group-level validators have no errors
  • formGroup.state.meta.isValid: true when both the field-level and group-level validators have no errors
  • formGroup.state.meta.isSubmitting: true when the group is in the process of being submitted

When building a multi-stage form that has many stages, like so:

It's common for each step to have its own form. However, this complicates the form submission and validation process by requiring you to add complex logic.
Luckily, TanStack Form provides a way to build out sub-forms that make this kind of development trivial to implement: <form.FormGroup>.
To use a form group in TanStack Form, you'll use useForm or useAppForm to create a form variable, then reference its FormGroup component like you would a Field:
const form = useForm({
defaultValues: {
step1: {
name: ""
},
step2: {
age: 0
}
}
})
return (
<form.FormGroup
name="step1"
children={group => (
// `group` here has all of the form-like methods you'd expect like `deleteField` or `insertFieldValue`
// ...
)}
/>
)const form = useForm({
defaultValues: {
step1: {
name: ""
},
step2: {
age: 0
}
}
})
return (
<form.FormGroup
name="step1"
children={group => (
// `group` here has all of the form-like methods you'd expect like `deleteField` or `insertFieldValue`
// ...
)}
/>
)This becomes much more useful when paired with external state to conditionally render a FormGroup:
const [step, setStep] = useState(0)
const form = useForm({
defaultValues: {
step1: {
name: ""
},
step2: {
age: 0
}
}
})
return (
<>
{step === 0 ? <form.FormGroup
name="step1"
onGroupSubmit={() => {
// We can move the step forward when validation passes
setStep(step + 1)
}}
onGroupSubmitInvalid={() => {
// Or handle invalid submissions, just like a top-level form
}}
onSubmitMeta={{} as SomeType}
children={group => (
// Use `group.handleSubmit()` to submit the sub-form, but not the parent form
// ...
)}
/> : null }
{step === 1 ? <form.FormGroup
name="step2"
children={group => (
// Then, use `form.handleSubmit()` to submit the entire form
// ...
)}
/> : null }
</>
)const [step, setStep] = useState(0)
const form = useForm({
defaultValues: {
step1: {
name: ""
},
step2: {
age: 0
}
}
})
return (
<>
{step === 0 ? <form.FormGroup
name="step1"
onGroupSubmit={() => {
// We can move the step forward when validation passes
setStep(step + 1)
}}
onGroupSubmitInvalid={() => {
// Or handle invalid submissions, just like a top-level form
}}
onSubmitMeta={{} as SomeType}
children={group => (
// Use `group.handleSubmit()` to submit the sub-form, but not the parent form
// ...
)}
/> : null }
{step === 1 ? <form.FormGroup
name="step2"
children={group => (
// Then, use `form.handleSubmit()` to submit the entire form
// ...
)}
/> : null }
</>
)Form groups have a distinct validation proceedure that we think makes sense for sub-forms:
<form.FormGroup
name="step1"
validators={{ onChange: () => 'Error' }}
children={(group) => {
group.state.meta.errorMap // {onChange: "Error" | undefined}
group.state.meta.errors // ("Error")[]
}}
/><form.FormGroup
name="step1"
validators={{ onChange: () => 'Error' }}
children={(group) => {
group.state.meta.errorMap // {onChange: "Error" | undefined}
group.state.meta.errors // ("Error")[]
}}
/><form.FormGroup
name="step1"
validators={{
onChange: ({ value, groupApi }) => ({
group: value.name === 'error' ? 'Group error' : undefined,
fields: {
// Must use the name of the field relative to the FormGroup as the error key,
// to stay consistent with how standard schema works with form groups
name: value.name === 'error' ? 'Field error' : undefined,
},
}),
}}
/><form.FormGroup
name="step1"
validators={{
onChange: ({ value, groupApi }) => ({
group: value.name === 'error' ? 'Group error' : undefined,
fields: {
// Must use the name of the field relative to the FormGroup as the error key,
// to stay consistent with how standard schema works with form groups
name: value.name === 'error' ? 'Field error' : undefined,
},
}),
}}
/><form.FormGroup
name="step1"
validators={{
onChange: z.object({
name: z.string().min(2),
}),
}}
/><form.FormGroup
name="step1"
validators={{
onChange: z.object({
name: z.string().min(2),
}),
}}
/>The reason we don't use the full path names for fields is so that you can compose your schemas like so:
plaintextconst step1Schema = z.object({ name: z.string().min(2) }) const schema = z.object({ step1: step1Schema, step2: step2Schema })const step1Schema = z.object({ name: z.string().min(2) }) const schema = z.object({ step1: step1Schema, step2: step2Schema })And pass the step1Schema to a form group and schema to the parent form. That way, partially validated data will still flag errors if the group is bypassed.
If you want to use dynamic validation (onDynamic) with a form group, do not rely on the onDynamic validator passed to useForm:
useForm({
validationLogic: revalidateLogic(),
validators: {
// This validator will not run `onChange` when a sub-form is submitted;
// it will only run `onChange` when the form itself is submitted.
onDynamic: schema,
},
})useForm({
validationLogic: revalidateLogic(),
validators: {
// This validator will not run `onChange` when a sub-form is submitted;
// it will only run `onChange` when the form itself is submitted.
onDynamic: schema,
},
})Instead, pass your sub-schema for the group to the onDynamic validation of the FormGroup itself:
<form.FormGroup validators={{ onDynamic: step1Schema }} /><form.FormGroup validators={{ onDynamic: step1Schema }} />It will treat group.submissionAttempts as the way to change what validator is ran before/after submit.
Just like you're able to access group.state.meta.errors, you're also able to access the group's value using group.state.value. Likewise, here are some valuable properties you can access in the group.state.meta:

Guides

Form Groups

When building a multi-stage form that has many stages, like so:

Form stepper

It's common for each step to have its own form. However, this complicates the form submission and validation process by requiring you to add complex logic.

Luckily, TanStack Form provides a way to build out sub-forms that make this kind of development trivial to implement: [tanstackFormGroup].

Usage

To use a form group in TanStack Form, you'll use injectForm to create a form variable, then reference it with the tanstackFormGroup directive like you would with tanstackField:

angular-ts
import { Component } from '@angular/core'
import { TanStackFormGroup, injectForm } from '@tanstack/angular-form'

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackFormGroup],
  template: `
    <ng-container [tanstackFormGroup]="form" name="step1" #group="formGroup">
      <!-- `group.api` here has all of the form-like methods you'd expect like `deleteField` or `insertFieldValue` -->
      <!-- ... -->
    </ng-container>
  `,
})
export class AppComponent {
  form = injectForm({
    defaultValues: {
      step1: {
        name: '',
      },
      step2: {
        age: 0,
      },
    },
  })
}
import { Component } from '@angular/core'
import { TanStackFormGroup, injectForm } from '@tanstack/angular-form'

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackFormGroup],
  template: `
    <ng-container [tanstackFormGroup]="form" name="step1" #group="formGroup">
      <!-- `group.api` here has all of the form-like methods you'd expect like `deleteField` or `insertFieldValue` -->
      <!-- ... -->
    </ng-container>
  `,
})
export class AppComponent {
  form = injectForm({
    defaultValues: {
      step1: {
        name: '',
      },
      step2: {
        age: 0,
      },
    },
  })
}

This becomes much more useful when paired with external state to conditionally render a form group:

angular-ts
import { Component, signal } from '@angular/core'
import {
  TanStackField,
  TanStackFormGroup,
  injectForm,
} from '@tanstack/angular-form'

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackField, TanStackFormGroup],
  template: `
    @if (step() === 0) {
      <ng-container
        [tanstackFormGroup]="form"
        name="step1"
        [onGroupSubmit]="onStep1Submit"
        [onGroupSubmitInvalid]="onStep1SubmitInvalid"
        [onSubmitMeta]="submitMeta"
        #group="formGroup"
      >
        <form
          (submit)="
            $event.preventDefault();
            $event.stopPropagation();
            group.api.handleSubmit()
          "
        >
          <ng-container [tanstackField]="form" name="step1.name" #name="field">
            <!-- ... -->
          </ng-container>
        </form>
      </ng-container>
    }

    @if (step() === 1) {
      <ng-container
        [tanstackFormGroup]="form"
        name="step2"
        [onGroupSubmit]="onStep2Submit"
        #group="formGroup"
      >
        <form
          (submit)="
            $event.preventDefault();
            $event.stopPropagation();
            group.api.handleSubmit()
          "
        >
          <ng-container [tanstackField]="form" name="step2.age" #age="field">
            <!-- ... -->
          </ng-container>
        </form>
      </ng-container>
    }
  `,
})
export class AppComponent {
  step = signal(0)
  submitMeta = {} as SomeType

  form = injectForm({
    defaultValues: {
      step1: {
        name: '',
      },
      step2: {
        age: 0,
      },
    },
  })

  onStep1Submit = () => {
    // We can move the step forward when validation passes
    this.step.update((step) => step + 1)
  }

  onStep1SubmitInvalid = () => {
    // Or handle invalid submissions, just like a top-level form
  }

  onStep2Submit = () => {
    // Then, use `form.handleSubmit()` to submit the entire form
    this.form.handleSubmit()
  }
}
import { Component, signal } from '@angular/core'
import {
  TanStackField,
  TanStackFormGroup,
  injectForm,
} from '@tanstack/angular-form'

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackField, TanStackFormGroup],
  template: `
    @if (step() === 0) {
      <ng-container
        [tanstackFormGroup]="form"
        name="step1"
        [onGroupSubmit]="onStep1Submit"
        [onGroupSubmitInvalid]="onStep1SubmitInvalid"
        [onSubmitMeta]="submitMeta"
        #group="formGroup"
      >
        <form
          (submit)="
            $event.preventDefault();
            $event.stopPropagation();
            group.api.handleSubmit()
          "
        >
          <ng-container [tanstackField]="form" name="step1.name" #name="field">
            <!-- ... -->
          </ng-container>
        </form>
      </ng-container>
    }

    @if (step() === 1) {
      <ng-container
        [tanstackFormGroup]="form"
        name="step2"
        [onGroupSubmit]="onStep2Submit"
        #group="formGroup"
      >
        <form
          (submit)="
            $event.preventDefault();
            $event.stopPropagation();
            group.api.handleSubmit()
          "
        >
          <ng-container [tanstackField]="form" name="step2.age" #age="field">
            <!-- ... -->
          </ng-container>
        </form>
      </ng-container>
    }
  `,
})
export class AppComponent {
  step = signal(0)
  submitMeta = {} as SomeType

  form = injectForm({
    defaultValues: {
      step1: {
        name: '',
      },
      step2: {
        age: 0,
      },
    },
  })

  onStep1Submit = () => {
    // We can move the step forward when validation passes
    this.step.update((step) => step + 1)
  }

  onStep1SubmitInvalid = () => {
    // Or handle invalid submissions, just like a top-level form
  }

  onStep2Submit = () => {
    // Then, use `form.handleSubmit()` to submit the entire form
    this.form.handleSubmit()
  }
}

When you split each step into its own component, pass the parent form down with tanstack-with-form and read it in the child with injectWithForm. The child can then use [tanstackFormGroup]="withForm.form" and [tanstackField]="withForm.form" against the same parent form instance.

Form Group Validation

Form groups have a distinct validation procedure that we think makes sense for sub-forms:

  • Form groups can have their own validation:
angular-ts
@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackFormGroup],
  template: `
    <ng-container
      [tanstackFormGroup]="form"
      name="step1"
      [validators]="{ onChange: groupValidator }"
      #group="formGroup"
    >
      <!-- group.api.state.meta.errorMap // {onChange: "Error" | undefined} -->
      <!-- group.api.state.meta.errors // ("Error")[] -->
    </ng-container>
  `,
})
export class AppComponent {
  form = injectForm({
    defaultValues: {
      step1: { name: '' },
    },
  })

  groupValidator = () => 'Error'
}
@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackFormGroup],
  template: `
    <ng-container
      [tanstackFormGroup]="form"
      name="step1"
      [validators]="{ onChange: groupValidator }"
      #group="formGroup"
    >
      <!-- group.api.state.meta.errorMap // {onChange: "Error" | undefined} -->
      <!-- group.api.state.meta.errors // ("Error")[] -->
    </ng-container>
  `,
})
export class AppComponent {
  form = injectForm({
    defaultValues: {
      step1: { name: '' },
    },
  })

  groupValidator = () => 'Error'
}
  • Can set errors on sub-fields:
angular-ts
@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackFormGroup],
  template: `
    <ng-container
      [tanstackFormGroup]="form"
      name="step1"
      [validators]="{ onChange: groupValidator }"
    ></ng-container>
  `,
})
export class AppComponent {
  form = injectForm({
    defaultValues: {
      step1: { name: '' },
    },
  })

  groupValidator = ({ value }: { value: { name: string } }) => ({
    group: value.name === 'error' ? 'Group error' : undefined,
    fields: {
      // Must use the name of the field relative to the FormGroup as the error key,
      // to stay consistent with how standard schema works with form groups
      name: value.name === 'error' ? 'Field error' : undefined,
    },
  })
}
@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackFormGroup],
  template: `
    <ng-container
      [tanstackFormGroup]="form"
      name="step1"
      [validators]="{ onChange: groupValidator }"
    ></ng-container>
  `,
})
export class AppComponent {
  form = injectForm({
    defaultValues: {
      step1: { name: '' },
    },
  })

  groupValidator = ({ value }: { value: { name: string } }) => ({
    group: value.name === 'error' ? 'Group error' : undefined,
    fields: {
      // Must use the name of the field relative to the FormGroup as the error key,
      // to stay consistent with how standard schema works with form groups
      name: value.name === 'error' ? 'Field error' : undefined,
    },
  })
}
  • And can even accept standard schemas:
angular-ts
import { z } from 'zod'

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackFormGroup],
  template: `
    <ng-container
      [tanstackFormGroup]="form"
      name="step1"
      [validators]="{ onChange: step1Schema }"
    ></ng-container>
  `,
})
export class AppComponent {
  step1Schema = z.object({
    name: z.string().min(2),
  })

  form = injectForm({
    defaultValues: {
      step1: { name: '' },
    },
  })
}
import { z } from 'zod'

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackFormGroup],
  template: `
    <ng-container
      [tanstackFormGroup]="form"
      name="step1"
      [validators]="{ onChange: step1Schema }"
    ></ng-container>
  `,
})
export class AppComponent {
  step1Schema = z.object({
    name: z.string().min(2),
  })

  form = injectForm({
    defaultValues: {
      step1: { name: '' },
    },
  })
}

The reason we don't use the full path names for fields is so that you can compose your schemas like so:

ts
const step1Schema = z.object({
  name: z.string().min(2),
})

const schema = z.object({
  step1: step1Schema,
  step2: step2Schema,
})
const step1Schema = z.object({
  name: z.string().min(2),
})

const schema = z.object({
  step1: step1Schema,
  step2: step2Schema,
})

And pass the step1Schema to a form group and schema to the parent form. That way, partially validated data will still flag errors if the group is bypassed.

Dynamic Group Validation

If you want to use dynamic validation (onDynamic) with a form group, do not rely on the onDynamic validator passed to injectForm:

ts
form = injectForm({
  validationLogic: revalidateLogic(),
  validators: {
    // This validator will not run `onChange` when a sub-form is submitted;
    // it will only run `onChange` when the form itself is submitted.
    onDynamic: schema,
  },
})
form = injectForm({
  validationLogic: revalidateLogic(),
  validators: {
    // This validator will not run `onChange` when a sub-form is submitted;
    // it will only run `onChange` when the form itself is submitted.
    onDynamic: schema,
  },
})

Instead, pass your sub-schema for the group to the onDynamic validation of the group itself:

angular-ts
@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackFormGroup],
  template: `
    <ng-container
      [tanstackFormGroup]="form"
      name="step1"
      [validators]="{ onDynamic: step1Schema }"
    ></ng-container>
  `,
})
export class AppComponent {
  step1Schema = step1Schema

  form = injectForm({
    defaultValues: {
      step1: { name: '' },
    },
  })
}
@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackFormGroup],
  template: `
    <ng-container
      [tanstackFormGroup]="form"
      name="step1"
      [validators]="{ onDynamic: step1Schema }"
    ></ng-container>
  `,
})
export class AppComponent {
  step1Schema = step1Schema

  form = injectForm({
    defaultValues: {
      step1: { name: '' },
    },
  })
}

It will treat group.api.submissionAttempts as the way to change what validator is run before/after submit.

Form Group State

Just like you're able to access group.api.state.meta.errors, you're also able to access the group's value using group.api.state.value. Likewise, here are some valuable properties you can access in the group.api.state.meta:

  • group.api.state.meta.isFieldsValid: true when the field-level validators have no errors
  • group.api.state.meta.isGroupValid: true when the group-level validators have no errors
  • group.api.state.meta.isValid: true when both the field-level and group-level validators have no errors
  • group.api.state.meta.isSubmitting: true when the group is in the process of being submitted

Guides

Form Groups

When building a multi-stage form that has many stages, like so:

Form stepper

It's common for each step to have its own form. However, this complicates the form submission and validation process by requiring you to add complex logic.

Luckily, TanStack Form provides a way to build out sub-forms that make this kind of development trivial to implement: <form.FormGroup>.

Usage

To use a form group in TanStack Form, you'll use createForm or createAppForm to create a form variable, then reference its FormGroup component like you would a Field:

svelte
<script lang="ts">
  import { createForm } from '@tanstack/svelte-form'

  const form = createForm(() => ({
    defaultValues: {
      step1: {
        name: '',
      },
      step2: {
        age: 0,
      },
    },
  }))
</script>

<form.FormGroup name="step1">
  {#snippet children(group)}
    <!-- `group` here has all of the form-like methods you'd expect like `deleteField` or `insertFieldValue` -->
    <!-- ... -->
  {/snippet}
</form.FormGroup>
<script lang="ts">
  import { createForm } from '@tanstack/svelte-form'

  const form = createForm(() => ({
    defaultValues: {
      step1: {
        name: '',
      },
      step2: {
        age: 0,
      },
    },
  }))
</script>

<form.FormGroup name="step1">
  {#snippet children(group)}
    <!-- `group` here has all of the form-like methods you'd expect like `deleteField` or `insertFieldValue` -->
    <!-- ... -->
  {/snippet}
</form.FormGroup>

This becomes much more useful when paired with external state to conditionally render a FormGroup:

svelte
<script lang="ts">
  import { createForm } from '@tanstack/svelte-form'

  let step = $state(0)

  const form = createForm(() => ({
    defaultValues: {
      step1: {
        name: '',
      },
      step2: {
        age: 0,
      },
    },
  }))
</script>

{#if step === 0}
  <form.FormGroup
    name="step1"
    onGroupSubmit={() => {
      // We can move the step forward when validation passes
      step++
    }}
    onGroupSubmitInvalid={() => {
      // Or handle invalid submissions, just like a top-level form
    }}
    onSubmitMeta={{} as SomeType}
  >
    {#snippet children(group)}
      <form
        onsubmit={(e) => {
          e.preventDefault()
          e.stopPropagation()
          // Use `group.handleSubmit()` to submit the sub-form, but not the parent form
          group.handleSubmit()
        }}
      >
        <!-- ... -->
      </form>
    {/snippet}
  </form.FormGroup>
{:else if step === 1}
  <form.FormGroup name="step2" onGroupSubmit={() => form.handleSubmit()}>
    {#snippet children(group)}
      <form
        onsubmit={(e) => {
          e.preventDefault()
          e.stopPropagation()
          group.handleSubmit()
        }}
      >
        <!-- Then, use `form.handleSubmit()` from `onGroupSubmit` to submit the entire form -->
        <!-- ... -->
      </form>
    {/snippet}
  </form.FormGroup>
{/if}
<script lang="ts">
  import { createForm } from '@tanstack/svelte-form'

  let step = $state(0)

  const form = createForm(() => ({
    defaultValues: {
      step1: {
        name: '',
      },
      step2: {
        age: 0,
      },
    },
  }))
</script>

{#if step === 0}
  <form.FormGroup
    name="step1"
    onGroupSubmit={() => {
      // We can move the step forward when validation passes
      step++
    }}
    onGroupSubmitInvalid={() => {
      // Or handle invalid submissions, just like a top-level form
    }}
    onSubmitMeta={{} as SomeType}
  >
    {#snippet children(group)}
      <form
        onsubmit={(e) => {
          e.preventDefault()
          e.stopPropagation()
          // Use `group.handleSubmit()` to submit the sub-form, but not the parent form
          group.handleSubmit()
        }}
      >
        <!-- ... -->
      </form>
    {/snippet}
  </form.FormGroup>
{:else if step === 1}
  <form.FormGroup name="step2" onGroupSubmit={() => form.handleSubmit()}>
    {#snippet children(group)}
      <form
        onsubmit={(e) => {
          e.preventDefault()
          e.stopPropagation()
          group.handleSubmit()
        }}
      >
        <!-- Then, use `form.handleSubmit()` from `onGroupSubmit` to submit the entire form -->
        <!-- ... -->
      </form>
    {/snippet}
  </form.FormGroup>
{/if}

Form Group Validation

Form groups have a distinct validation procedure that we think makes sense for sub-forms:

  • Form groups can have their own validation:
svelte
<form.FormGroup name="step1" validators={{ onChange: () => 'Error' }}>
  {#snippet children(group)}
    <!-- group.state.meta.errorMap // {onChange: "Error" | undefined} -->
    <!-- group.state.meta.errors // ("Error")[] -->
  {/snippet}
</form.FormGroup>
<form.FormGroup name="step1" validators={{ onChange: () => 'Error' }}>
  {#snippet children(group)}
    <!-- group.state.meta.errorMap // {onChange: "Error" | undefined} -->
    <!-- group.state.meta.errors // ("Error")[] -->
  {/snippet}
</form.FormGroup>
  • Can set errors on sub-fields:
svelte
<form.FormGroup
  name="step1"
  validators={{
    onChange: ({ value, groupApi }) => ({
      group: value.name === 'error' ? 'Group error' : undefined,
      fields: {
        // Must use the name of the field relative to the FormGroup as the error key,
        // to stay consistent with how standard schema works with form groups
        name: value.name === 'error' ? 'Field error' : undefined,
      },
    }),
  }}
/>
<form.FormGroup
  name="step1"
  validators={{
    onChange: ({ value, groupApi }) => ({
      group: value.name === 'error' ? 'Group error' : undefined,
      fields: {
        // Must use the name of the field relative to the FormGroup as the error key,
        // to stay consistent with how standard schema works with form groups
        name: value.name === 'error' ? 'Field error' : undefined,
      },
    }),
  }}
/>
  • And can even accept standard schemas:
svelte
<form.FormGroup
  name="step1"
  validators={{
    onChange: z.object({
      name: z.string().min(2),
    }),
  }}
/>
<form.FormGroup
  name="step1"
  validators={{
    onChange: z.object({
      name: z.string().min(2),
    }),
  }}
/>

The reason we don't use the full path names for fields is so that you can compose your schemas like so:

ts
const step1Schema = z.object({
  name: z.string().min(2),
})

const schema = z.object({
  step1: step1Schema,
  step2: step2Schema,
})
const step1Schema = z.object({
  name: z.string().min(2),
})

const schema = z.object({
  step1: step1Schema,
  step2: step2Schema,
})

And pass the step1Schema to a form group and schema to the parent form. That way, partially validated data will still flag errors if the group is bypassed.

Dynamic Group Validation

If you want to use dynamic validation (onDynamic) with a form group, do not rely on the onDynamic validator passed to createForm:

ts
createForm(() => ({
  validationLogic: revalidateLogic(),
  validators: {
    // This validator will not run `onChange` when a sub-form is submitted;
    // it will only run `onChange` when the form itself is submitted.
    onDynamic: schema,
  },
}))
createForm(() => ({
  validationLogic: revalidateLogic(),
  validators: {
    // This validator will not run `onChange` when a sub-form is submitted;
    // it will only run `onChange` when the form itself is submitted.
    onDynamic: schema,
  },
}))

Instead, pass your sub-schema for the group to the onDynamic validation of the FormGroup itself:

svelte
<form.FormGroup name="step1" validators={{ onDynamic: step1Schema }} />
<form.FormGroup name="step1" validators={{ onDynamic: step1Schema }} />

It will treat group.submissionAttempts as the way to change what validator is ran before/after submit.

Form Group State

Just like you're able to access group.state.meta.errors, you're also able to access the group's value using group.state.value. Likewise, here are some valuable properties you can access in the group.state.meta:

  • group.state.meta.isFieldsValid: true when the field-level validators have no errors
  • group.state.meta.isGroupValid: true when the group-level validators have no errors
  • group.state.meta.isValid: true when both the field-level and group-level validators have no errors
  • group.state.meta.isSubmitting: true when the group is in the process of being submitted